Attribute VB_Name = "mdlCrypt"
Option Explicit

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileW" ( _
    ByVal lpFileName As String, _
     ByVal dwDesiredAccess As Long, _
     ByVal dwShareMode As Long, _
     ByVal lpSecurityAttributes As Long, _
     ByVal dwCreationDisposition As Long, _
     ByVal dwFlagsAndAttributes As Long, _
     ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hHandle As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByRef lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, ByRef lpNumberOfBytesRead As Long, ByRef lpOverlapped As Any) As Long

Private Declare Function CryptAcquireContext Lib "advapi32" Alias "CryptAcquireContextA" (ByRef phProv As Long, ByVal pszContainer As String, ByVal pszProvider As String, ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptCreateHash Lib "advapi32" (ByVal hProv As Long, ByVal Algid As Long, ByVal hKey As Long, ByVal dwFlags As Long, ByRef phHash As Long) As Long
Private Declare Function CryptHashData Lib "advapi32" (ByVal hHash As Long, ByRef pbData As Any, ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptGetHashParam Lib "advapi32" (ByVal hHash As Long, ByVal dwParam As Long, ByRef pbData As Any, ByRef pdwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptDestroyHash Lib "advapi32" (ByVal hHash As Long) As Long
Private Declare Function CryptReleaseContext Lib "advapi32" (ByVal hProv As Long, ByVal dwFlags As Long) As Long
'--------------------------------------------------------------
Private Const GENERIC_WRITE As Long = &H40000000
Private Const GENERIC_READ As Long = &H80000000
Private Const FILE_ATTRIBUTE_READONLY As Long = &H1
Private Const FILE_ATTRIBUTE_HIDDEN As Long = &H2
Private Const FILE_ATTRIBUTE_SYSTEM As Long = &H4
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80
Private Const FILE_SHARE_READ As Long = 1
Private Const OPEN_EXISTING As Long = 3
Private Const INVALID_HANDLE_VALUE As Long = -1
Private Const PROV_RSA_FULL  As Long = 1
Private Const CALG_MD5 As Long = 32771 '&H8003
Private Const HP_HASHVAL As Long = 2
Private Const HP_HASHSIZE As Long = 4
'**************************************************************


Public Function GetMD5(ByVal FileName As String) As String
    Dim result As Long
    Dim hProv As Long
    Dim hHash As Long
    Dim bBuff() As Byte
    Dim dwLen As Long
    Const BUFFER_SIZE As Long = 4096
    
    ' ϐ
    GetMD5 = ""
    hProv = 0
    hHash = 0
    
    result = CryptAcquireContext(hProv, vbNullString, vbNullString, PROV_RSA_FULL, 0)
    If result = API_FALSE Then GoTo ErrorHandler
    
    result = CryptCreateHash(hProv, CALG_MD5, 0, 0, hHash)
    If result = API_FALSE Then GoTo ErrorHandler
    
    'nbVf[^ɒǉ
    Dim FN As Integer
    Dim fsize As Long
    FN = FreeFile
    fsize = FileLen(FileName)
    On Error GoTo ErrorHandler
    Open FileName For Binary As #FN
    On Error GoTo 0
    Do While fsize > 0
        If fsize <= BUFFER_SIZE Then
            dwLen = fsize
            fsize = 0
        Else
            dwLen = BUFFER_SIZE
            fsize = fsize - BUFFER_SIZE
        End If
        ReDim bBuff(dwLen - 1)
        Get #FN, , bBuff
    
        result = CryptHashData(hHash, bBuff(0), dwLen, 0)
        If result = API_FALSE Then GoTo ErrorHandler
    Loop
    Close #FN
    
    ' nbVvZ
    Dim pbHash() As Byte
    dwLen = 0
    result = CryptGetHashParam(hHash, HP_HASHVAL, ByVal 0, dwLen, 0)
    If result = API_FALSE Then GoTo ErrorHandler
    ReDim pbHash(dwLen - 1)
    result = CryptGetHashParam(hHash, HP_HASHVAL, pbHash(0), dwLen, 0)
    
    ' 
    Dim i As Long
    For i = LBound(pbHash) To UBound(pbHash)
        GetMD5 = GetMD5 & Right$("00" & Hex$(pbHash(i)), 2)
    Next i
    GetMD5 = StrConv(GetMD5, vbLowerCase)
    
ErrorHandler:
    Close #FN
    If hHash <> 0 Then
        Call CryptDestroyHash(hHash)
    End If
    If hProv <> 0 Then
        Call CryptReleaseContext(hProv, 0)
    End If
End Function
